# coding: utf-8

"""
    Barion API

    Integrate with ease and get unbeatable fees and data that helps you grow your business.

    The version of the OpenAPI document: 0.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from clientapi_barion.models.beneficiary import Beneficiary
from typing import Optional, Set
from typing_extensions import Self

class AccountInfo(BaseModel):
    """
    AccountInfo
    """ # noqa: E501
    bban_country: Optional[Annotated[str, Field(min_length=3, strict=True, max_length=3)]] = Field(default=None, description="ISO-3 country code of the country for the currency of the account.", alias="BBANCountry")
    bban: Optional[StrictStr] = Field(default=None, description="The BBAN (local bank account number) of the account for wire transfer topups (for HUF and CZK).", alias="BBAN")
    iban: Optional[StrictStr] = Field(default=None, description="The IBAN (international bank account number) of the account for wire transfer topups.", alias="IBAN")
    reference: Optional[StrictStr] = Field(default=None, description="Code used in conjunction with the bank account number for topups to a Barion deposit account.", alias="Reference")
    swift_code: Optional[StrictStr] = Field(default=None, description="The Swift code of the bank for wire transfer topups.", alias="SwiftCode")
    beneficiary: Optional[Beneficiary] = Field(default=None, alias="Beneficiary")
    __properties: ClassVar[List[str]] = ["BBANCountry", "BBAN", "IBAN", "Reference", "SwiftCode", "Beneficiary"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of beneficiary
        if self.beneficiary:
            _dict['Beneficiary'] = self.beneficiary.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "BBANCountry": obj.get("BBANCountry"),
            "BBAN": obj.get("BBAN"),
            "IBAN": obj.get("IBAN"),
            "Reference": obj.get("Reference"),
            "SwiftCode": obj.get("SwiftCode"),
            "Beneficiary": Beneficiary.from_dict(obj["Beneficiary"]) if obj.get("Beneficiary") is not None else None
        })
        return _obj


