# coding: utf-8

"""
    Barion API

    Integrate with ease and get unbeatable fees and data that helps you grow your business.

    The version of the OpenAPI document: 0.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from clientapi_barion.models.processed_transaction import ProcessedTransaction
from typing import Optional, Set
from typing_extensions import Self

class PaymentFinishReservationResponse(BaseModel):
    """
    PaymentFinishReservationResponse
    """ # noqa: E501
    is_successful: Optional[StrictBool] = Field(default=None, description="Result of the transaction.", alias="IsSuccessful")
    payment_id: Optional[StrictStr] = Field(default=None, description="The identifier of the newly initialized payment, generated by the Barion system.", alias="PaymentId")
    payment_request_id: Optional[StrictStr] = Field(default=None, description="The payment identifier supplied by the API caller in the request.", alias="PaymentRequestId")
    status: Optional[StrictStr] = Field(default=None, description="The status of the payment in the Barion system.", alias="Status")
    transactions: Optional[List[ProcessedTransaction]] = Field(default=None, alias="Transactions")
    __properties: ClassVar[List[str]] = ["IsSuccessful", "PaymentId", "PaymentRequestId", "Status", "Transactions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PaymentFinishReservationResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in transactions (list)
        _items = []
        if self.transactions:
            for _item_transactions in self.transactions:
                if _item_transactions:
                    _items.append(_item_transactions.to_dict())
            _dict['Transactions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PaymentFinishReservationResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "IsSuccessful": obj.get("IsSuccessful"),
            "PaymentId": obj.get("PaymentId"),
            "PaymentRequestId": obj.get("PaymentRequestId"),
            "Status": obj.get("Status"),
            "Transactions": [ProcessedTransaction.from_dict(_item) for _item in obj["Transactions"]] if obj.get("Transactions") is not None else None
        })
        return _obj


