# coding: utf-8

"""
    Barion API

    Integrate with ease and get unbeatable fees and data that helps you grow your business.

    The version of the OpenAPI document: 0.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class RefundedTransaction(BaseModel):
    """
    RefundedTransaction
    """ # noqa: E501
    transaction_id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the transaction in the Barion system.", alias="TransactionId")
    pos_transaction_id: Optional[StrictStr] = Field(default=None, description="The unique identifier of the transaction at the shop that initiated the payment.", alias="POSTransactionId")
    total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount that has been refunded from the given transaction.", alias="Total")
    comment: Optional[StrictStr] = Field(default=None, description="The comment associated with the refund.", alias="Comment")
    status: Optional[StrictStr] = Field(default=None, alias="Status")
    __properties: ClassVar[List[str]] = ["TransactionId", "POSTransactionId", "Total", "Comment", "Status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RefundedTransaction from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RefundedTransaction from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "TransactionId": obj.get("TransactionId"),
            "POSTransactionId": obj.get("POSTransactionId"),
            "Total": obj.get("Total"),
            "Comment": obj.get("Comment"),
            "Status": obj.get("Status")
        })
        return _obj


