# coding: utf-8

"""
    Barion API

    Integrate with ease and get unbeatable fees and data that helps you grow your business.

    The version of the OpenAPI document: 0.1.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from clientapi_barion.models.item import Item
from clientapi_barion.models.payee_transaction_to_finish import PayeeTransactionToFinish
from typing import Optional, Set
from typing_extensions import Self

class TransactionToFinish(BaseModel):
    """
    TransactionToFinish
    """ # noqa: E501
    transaction_id: StrictStr = Field(description="The unique identifier of the transaction in the Barion system.", alias="TransactionId")
    total: Union[Annotated[float, Field(strict=True, ge=0)], Annotated[int, Field(strict=True, ge=0)]] = Field(description="The total amount of the transaction.", alias="Total")
    comment: Optional[Annotated[str, Field(strict=True, max_length=640)]] = Field(default=None, description="A comment associated with the transaction.", alias="Comment")
    payee_transactions: Optional[List[PayeeTransactionToFinish]] = Field(default=None, alias="PayeeTransactions")
    items: Optional[List[Item]] = Field(default=None, alias="Items")
    __properties: ClassVar[List[str]] = ["TransactionId", "Total", "Comment", "PayeeTransactions", "Items"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TransactionToFinish from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in payee_transactions (list)
        _items = []
        if self.payee_transactions:
            for _item_payee_transactions in self.payee_transactions:
                if _item_payee_transactions:
                    _items.append(_item_payee_transactions.to_dict())
            _dict['PayeeTransactions'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item_items in self.items:
                if _item_items:
                    _items.append(_item_items.to_dict())
            _dict['Items'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TransactionToFinish from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "TransactionId": obj.get("TransactionId"),
            "Total": obj.get("Total"),
            "Comment": obj.get("Comment"),
            "PayeeTransactions": [PayeeTransactionToFinish.from_dict(_item) for _item in obj["PayeeTransactions"]] if obj.get("PayeeTransactions") is not None else None,
            "Items": [Item.from_dict(_item) for _item in obj["Items"]] if obj.get("Items") is not None else None
        })
        return _obj


